/* $Id: cpl_errorstate.h,v 1.3 2008/07/21 08:48:39 llundin Exp $
 *
 * This file is part of the ESO Common Pipeline Library
 * Copyright (C) 2001-2008 European Southern Observatory
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * $Author: llundin $
 * $Date: 2008/07/21 08:48:39 $
 * $Revision: 1.3 $
 * $Name: cpl-4_2_0b3 $
 */

#ifndef CPL_ERRORSTATE_H
#define CPL_ERRORSTATE_H

#include <cpl_macros.h>

#include <cpl_type.h>
 
CPL_BEGIN_DECLS

/*-----------------------------------------------------------------------------
                           Defines
 -----------------------------------------------------------------------------*/

#ifndef CPL_ERROR_HISTORY_SIZE
#define CPL_ERROR_HISTORY_SIZE 20
#endif

typedef const void * cpl_errorstate;

/*-----------------------------------------------------------------------------
                           Prototypes of functions 
 -----------------------------------------------------------------------------*/

cpl_errorstate cpl_errorstate_get(void);
void cpl_errorstate_set(cpl_errorstate);
cpl_boolean cpl_errorstate_is_equal(cpl_errorstate);

void cpl_errorstate_dump(cpl_errorstate,
                         cpl_boolean,
                         void (*)(unsigned, unsigned, unsigned));

void cpl_errorstate_dump_one(unsigned, unsigned, unsigned);


CPL_END_DECLS

#endif
/* end of cpl_errorstate.h */
